package cn.com.infosec.asn1.cryptopro;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1OctetString;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERObjectIdentifier;
import cn.com.infosec.asn1.DERSequence;
import java.util.Enumeration;

public class GOST28147Parameters extends ASN1Encodable {
   ASN1OctetString iv;
   DERObjectIdentifier paramSet;

   public static GOST28147Parameters getInstance(ASN1TaggedObject obj, boolean explicit) {
      return getInstance(ASN1Sequence.getInstance(obj, explicit));
   }

   public static GOST28147Parameters getInstance(Object obj) {
      if (obj != null && !(obj instanceof GOST28147Parameters)) {
         if (obj instanceof ASN1Sequence) {
            return new GOST28147Parameters((ASN1Sequence)obj);
         } else {
            throw new IllegalArgumentException("Invalid GOST3410Parameter: " + obj.getClass().getName());
         }
      } else {
         return (GOST28147Parameters)obj;
      }
   }

   public GOST28147Parameters(ASN1Sequence seq) {
      GOST28147Parameters var10000 = this;
      super();
      Enumeration var2;
      this.iv = (ASN1OctetString)(var2 = seq.getObjects()).nextElement();
      var10000.paramSet = (DERObjectIdentifier)var2.nextElement();
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10000 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var1.add(this.iv);
      var10000.add(this.paramSet);
      return new DERSequence(var1);
   }
}
